=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

http://synergy-foss.org/download/\?list \?file=synergy-([\d\.]+)-.*-Source\.tar\.gz
